;; Copy the two commented lines below in your init.lsp in your home directory,
;; uncomment them, and replace the string THIS_FILE by the directory where
;; your master will run.  This is in order to re-direct the slave's attention
;; back to this file.  Then name this file init.lsp in the directory where
;; your master will run.
;; (Eventually, we should just modify pargcl script to -eval this.)

;; If calling a slave with no faslink, need to load GCL/MPI package
;; (when (and (si::get-command-arg "-p4amslave") (not (find-package "MPI")))
;;   (load "THIS_FILE"))

(let ((command (si::argv 0))
      (pargcl-nofaslink-p t))  ; Assume it's t
;;This doesn't work, since (si::argv 0) will not be pargcl script.
;  (dotimes (i (max 0 (the fixnum (- (length command) 3))))
;    (if (and (eql (aref command i) #\m)
;	     (string-equal (subseq command i (the fixnum (+ i 3))) "mpi"))
;        (return (setq pargcl-nofaslink-p t))))
  ;;This code executed only if GCL called with name that includes "mpi"
  (when (and pargcl-nofaslink-p (not (find-package "MPI")))
    (let ((old-dir (truename "."))) ;; hack to get .data file loaded
      (unwind-protect
        (progn ; temporarily change to same directory as this file
          (si::chdir (directory-namestring (truename si:*load-pathname*)))
          (unless (probe-file "mpi_glue.data")
	    (warn "alpha version and some others require .o and .data file")
	    (warn "IBM RS6000 requires .o file only"))
          (load "mpi_glue.o")
          (load "slave-listener.lsp")
          (load "master-slave.lsp"))
        (si::chdir old-dir)))
    ;; same as (mpi::init-slave-listener), but reader doesn't know MPI pkg yet.
    (funcall (symbol-function (find-symbol "INIT-SLAVE-LISTENER" "MPI")))))
